# Contributing to Algolia [Unofficial]

## Create a new issue

The easiest way to get involved is to create a [new issue](https://github.com/knxopo/dart_algolia/issues/new) when you spot a bug, if the documentation is incomplete or out of date, or if you identify an implementation problem.

## General coding guidelines

If you'd like to add a feature or fix a bug, we're more than happy to accept pull requests! We only ask a few things:

- Ensure your code contains no analyzer errors, e.g.
  - Code is strong-mode compliant
  - Code is free of lint errors
- Format your code with `dart format lib test`
- Analyze your code with `dart analyze lib --fatal-warnings --fatal-infos`
- Write tests for all new code paths, consider using the [Asynchronous Tests](https://pub.dartlang.org/packages/test#asynchronous-tests) available from the test package.
- Write helpful documentation
- If you would like to make a bigger / fundamental change to the codebase, please file a lightweight example PR / issue, or contact us in [Email](mailto:nhathiwala@knoxpo.com) so we can discuss the issue.
